Index: vendors/IOIPSL/current/src/mathelp.f90
===================================================================
--- vendors/IOIPSL/current/src/mathelp.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/mathelp.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE mathelp
 !-
-!$Id: mathelp.f90 440 2008-11-26 10:58:38Z bellier $
+!$Id: mathelp.f90 845 2009-12-10 16:26:03Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -28,6 +28,5 @@
 CONTAINS
 !===
-SUBROUTINE buildop (str,ex_topps,topp,nbops_max, &
- &                  missing_val,opps,scal,nbops)
+SUBROUTINE buildop (c_str,ex_topps,topp,fill_val,opps,scal,nbops)
 !---------------------------------------------------------------------
 !- This subroutine decomposes the input string in the elementary
@@ -39,21 +38,25 @@
 !- INPUT
 !-
-!- str      : String containing the operations
-!- ex_toops : The time operations that can be expected
-!-            within the string
+!- c_str    : String containing the operations
+!- ex_toops : Time operations that can be expected within the string
+!- fill_val :
 !-
 !- OUTPUT
 !-
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=80) :: str
-  CHARACTER(LEN=*) :: ex_topps
-  CHARACTER(LEN=7) :: topp
-  INTEGER :: nbops_max,nbops
-  CHARACTER(LEN=7) :: opps(nbops_max)
-  REAL :: scal(nbops_max),missing_val
-!-
-  CHARACTER(LEN=80) :: new_str
+!- topp   : Time operation
+!- opps   :
+!- scal   :
+!- nbops  :
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*),INTENT(IN) :: c_str,ex_topps
+  CHARACTER(LEN=*),INTENT(OUT) :: topp
+  CHARACTER(LEN=*),DIMENSION(:),INTENT(OUT) :: opps
+  REAL,INTENT(IN) :: fill_val
+  REAL,DIMENSION(:),INTENT(OUT) :: scal
+  INTEGER,INTENT(OUT) :: nbops
+!-
+  CHARACTER(LEN=LEN(c_str)) :: str,new_str
   INTEGER :: leng,ind_opb,ind_clb
 !-
@@ -62,4 +65,5 @@
   IF (check) WRITE(*,*) 'buildop : Some preliminary cleaning'
 !-
+  str = c_str
   leng = LEN_TRIM(str)
   IF ( str(1:1) == '(' .AND. str(leng:leng) == ')' ) THEN
@@ -94,5 +98,5 @@
  &          ' buildop : Call decoop ',new_str,ind_opb,ind_clb
         ENDIF
-        CALL decoop (new_str,nbops_max,missing_val,opps,scal,nbops)
+        CALL decoop (new_str,fill_val,opps,scal,nbops)
       ELSE
         CALL ipslerr(3,'buildop', &
@@ -115,18 +119,19 @@
 END SUBROUTINE buildop
 !===
-SUBROUTINE decoop (pstr,nbops_max,missing_val,opps,scal,nbops)
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=80) :: pstr
-  INTEGER :: nbops_max,nbops
-  CHARACTER(LEN=7) :: opps(nbops_max)
-  REAL :: scal(nbops_max),missing_val
-!-
-  CHARACTER(LEN=1) :: f_char(2),s_char(2)
-  INTEGER :: nbsep,f_pos(2),s_pos(2)
+SUBROUTINE decoop (pstr,fill_val,opps,scal,nbops)
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*),INTENT(IN) :: pstr
+  REAL,INTENT(IN) :: fill_val
+  CHARACTER(LEN=*),DIMENSION(:),INTENT(OUT) :: opps
+  REAL,DIMENSION(:),INTENT(OUT) :: scal
+  INTEGER,INTENT(OUT) :: nbops
+!-
+  CHARACTER(LEN=1),DIMENSION(2) :: f_char,s_char
+  INTEGER,DIMENSION(2) :: f_pos,s_pos
   CHARACTER(LEN=20) :: opp_str,scal_str
-  CHARACTER(LEN=80) :: str
-  INTEGER :: xpos,leng,ppos,epos,int_tmp
+  CHARACTER(LEN=LEN(pstr)) :: str
+  INTEGER :: nbsep,nbops_max,xpos,leng,ppos,epos,int_tmp
   CHARACTER(LEN=3) :: tl,dl
   CHARACTER(LEN=10) :: fmt
@@ -134,12 +139,18 @@
   LOGICAL :: check = .FALSE.,prio
 !---------------------------------------------------------------------
-  IF (check) WRITE(*,'(2a)') ' decoop : Incoming string : ',pstr
-!-
-  nbops = 0
-  str = pstr
+  IF (check) WRITE(*,'(2A)') ' decoop : Incoming string : ',pstr
+!-
+  str = pstr; nbops = 0;
 !-
   CALL findsep (str,nbsep,f_char,f_pos,s_char,s_pos)
   IF (check) WRITE(*,*) 'decoop : Out of findsep',nbsep
+!-
+  nbops_max = min(SIZE(opps),SIZE(scal))
+!-
   DO WHILE (nbsep > 0)
+    IF (nbops >= nbops_max) THEN
+      CALL ipslerr(3,'decoop','Expression too complex',TRIM(str),' ')
+    ENDIF
+!--
     xpos = INDEX(str,'X')
     leng = LEN_TRIM(str)
@@ -147,14 +158,9 @@
 !--
     IF (check) THEN
-      WRITE(*,*) 'decoop : str -->',str(1:leng)
+      WRITE(*,*) 'decoop : str   -> ',TRIM(str)
+      WRITE(*,*) 'decoop : nbops -> ',nbops
       WRITE(*,*) s_char(1),'-',f_char(1),'|',f_char(2),'-',s_char(2)
       WRITE(*,*) s_pos(1),'-',f_pos(1),'|',f_pos(2),'-',s_pos(2)
     ENDIF
-!--
-    IF (nbops > nbops_max-1) THEN
-      CALL ipslerr(3,'decoop','Expression too complex',str,' ')
-    ENDIF
-!--
-    IF (check) WRITE(*,*) 'decoop : --',nbops,' ',str(1:leng)
 !---
 !-- Start the analysis of the syntax. 3 types of constructs
@@ -236,5 +242,5 @@
       IF (INDEX(funcs,opp_str(1:LEN_TRIM(opp_str))) > 0) THEN
         opps(nbops) = opp_str(1:LEN_TRIM(opp_str))
-        scal(nbops) =  missing_val
+        scal(nbops) = fill_val
       ELSE
         CALL ipslerr(3,'decoop', &
@@ -313,10 +319,10 @@
   IMPLICIT NONE
 !-
-  CHARACTER(LEN=80) :: str
+  CHARACTER(LEN=*),INTENT(INOUT) :: str
   INTEGER :: nbsep
   CHARACTER(LEN=1),DIMENSION(2) :: f_char,s_char
   INTEGER,DIMENSION(2) :: f_pos,s_pos
 !-
-  CHARACTER(LEN=70) :: str_tmp
+  CHARACTER(LEN=10) :: str_tmp
   LOGICAL :: f_found,s_found
   INTEGER :: ind,xpos,leng,i
@@ -385,5 +391,5 @@
     WRITE(str_tmp,'("number :",I3)') nbsep
     CALL ipslerr(3,'findsep', &
- &    'How can I find that many separators',str_tmp,str)
+ &    'How can I find that many separators',str_tmp,TRIM(str))
   ENDIF
 !-
@@ -399,5 +405,5 @@
   IMPLICIT NONE
 !-
-  CHARACTER(LEN=80) :: str
+  CHARACTER(LEN=*),INTENT(INOUT) :: str
 !-
   INTEGER :: ind,leng,ic,it
Index: vendors/IOIPSL/current/src/stringop.f90
===================================================================
--- vendors/IOIPSL/current/src/stringop.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/stringop.f90	(revision 1991)
@@ -1,14 +1,8 @@
 MODULE stringop
 !-
-!$Id: stringop.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: stringop.f90 936 2010-03-04 11:01:32Z bellier $
 !-
 ! This software is governed by the CeCILL license
 ! See IOIPSL/IOIPSL_License_CeCILL.txt
-!---------------------------------------------------------------------
-!-
-  INTEGER,DIMENSION(30) :: &
- & prime=(/1,2,3,5,7,11,13,17,19,23,29,31,37,41,43, &
- & 47,53,59,61,67,71,73,79,83,89,97,101,103,107,109/)
-!-
 !---------------------------------------------------------------------
 CONTAINS
@@ -160,78 +154,31 @@
 END SUBROUTINE struppercase
 !===
-SUBROUTINE gensig (str,sig)
+SUBROUTINE str_xfw (c_string,c_word,l_ok)
 !---------------------------------------------------------------------
-!- Generate a signature from the first 30 characters of the string
-!- This signature is not unique and thus when one looks for the
-!- one needs to also verify the string.
+!- Given a character string "c_string", of arbitrary length,
+!- returns a logical flag "l_ok" if a word is found in it,
+!- the first word "c_word" if found and the new string "c_string"
+!- without the first word "c_word"
 !---------------------------------------------------------------------
-  IMPLICIT NONE
+  CHARACTER(LEN=*),INTENT(INOUT) :: c_string
+  CHARACTER(LEN=*),INTENT(OUT) :: c_word
+  LOGICAL,INTENT(OUT) :: l_ok
 !-
-  CHARACTER(LEN=*) :: str
-  INTEGER          :: sig
-!-
-  INTEGER :: i
+  INTEGER :: i_b,i_e
 !---------------------------------------------------------------------
-  sig = 0
-  DO i=1,MIN(LEN_TRIM(str),30)
-    sig = sig + prime(i)*IACHAR(str(i:i))
-  ENDDO
-!--------------------
-END SUBROUTINE gensig
-!===
-SUBROUTINE find_sig (nb_sig,str_tab,str,sig_tab,sig,pos)
-!---------------------------------------------------------------------
-!- Find the string signature in a list of signatures
-!---------------------------------------------------------------------
-!- INPUT
-!-   nb_sig      : length of table of signatures
-!-   str_tab     : Table of strings
-!-   str         : Target string we are looking for
-!-   sig_tab     : Table of signatures
-!-   sig         : Target signature we are looking for
-!- OUTPUT
-!-   pos         : -1 if str not found, else value in the table
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: nb_sig
-  CHARACTER(LEN=*),DIMENSION(nb_sig) :: str_tab
-  CHARACTER(LEN=*) :: str
-  INTEGER,DIMENSION(nb_sig) :: sig_tab
-  INTEGER :: sig
-!-
-  INTEGER :: pos
-  INTEGER,DIMENSION(nb_sig) :: loczeros
-!-
-  INTEGER :: il,len
-  INTEGER,DIMENSION(1) :: minpos
-!---------------------------------------------------------------------
-  pos = -1
-  il = LEN_TRIM(str)
-!-
-  IF ( nb_sig > 0 ) THEN
-    loczeros = ABS(sig_tab(1:nb_sig)-sig)
-    IF ( COUNT(loczeros < 1) == 1 ) THEN
-      minpos = MINLOC(loczeros)
-      len = LEN_TRIM(str_tab(minpos(1)))
-      IF (     (INDEX(str_tab(minpos(1)),str(1:il)) > 0) &
-          .AND.(len == il) ) THEN
-        pos = minpos(1)
-      ENDIF
-    ELSE IF ( COUNT(loczeros < 1) > 1 ) THEN
-      DO WHILE (COUNT(loczeros < 1) >= 1 .AND. pos < 0 )
-        minpos = MINLOC(loczeros)
-        len = LEN_TRIM(str_tab(minpos(1)))
-        IF (     (INDEX(str_tab(minpos(1)),str(1:il)) > 0) &
-            .AND.(len == il) ) THEN
-          pos = minpos(1)
-        ELSE
-          loczeros(minpos(1)) = 99999
-        ENDIF
-      ENDDO
+  l_ok = (LEN_TRIM(c_string) > 0)
+  IF (l_ok) THEN
+    i_b = VERIFY(c_string,' ')
+    i_e = INDEX(c_string(i_b:),' ')
+    IF (i_e == 0) THEN
+      c_word = c_string(i_b:)
+      c_string = ""
+    ELSE
+      c_word = c_string(i_b:i_b+i_e-2)
+      c_string = ADJUSTL(c_string(i_b+i_e-1:))
     ENDIF
   ENDIF
-!-----------------------
- END SUBROUTINE find_sig
+!---------------------
+END SUBROUTINE str_xfw
 !===
 !------------------
Index: vendors/IOIPSL/current/tools/flio_rbld.f90
===================================================================
--- vendors/IOIPSL/current/tools/flio_rbld.f90	(revision 1989)
+++ vendors/IOIPSL/current/tools/flio_rbld.f90	(revision 1991)
@@ -1,5 +1,5 @@
 PROGRAM flio_rbld
 !
-!$Id: flio_rbld.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: flio_rbld.f90 1025 2010-05-20 07:49:57Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -602,12 +602,14 @@
     ENDIF
 !-- copy all variable attributes
-    ALLOCATE(v_a_nm(v_a_nb))
-    CALL flioinqv (f_id_i1,TRIM(f_v_nm(iv)),l_ex,cn_atts=v_a_nm)
-    DO ia=1,v_a_nb
-      CALL fliocpya &
- &     (f_id_i1,TRIM(f_v_nm(iv)),TRIM(v_a_nm(ia)), &
- &      f_id_o,TRIM(f_v_nm(iv)))
-    ENDDO
-    DEALLOCATE(v_a_nm)
+    IF (v_a_nb > 0) THEN
+      ALLOCATE(v_a_nm(v_a_nb))
+      CALL flioinqv (f_id_i1,TRIM(f_v_nm(iv)),l_ex,cn_atts=v_a_nm)
+      DO ia=1,v_a_nb
+        CALL fliocpya &
+ &       (f_id_i1,TRIM(f_v_nm(iv)),TRIM(v_a_nm(ia)), &
+ &        f_id_o,TRIM(f_v_nm(iv)))
+      ENDDO
+      DEALLOCATE(v_a_nm)
+    ENDIF
   ENDDO
 !-
Index: vendors/IOIPSL/current/tools/rebuild
===================================================================
--- vendors/IOIPSL/current/tools/rebuild	(revision 1989)
+++ vendors/IOIPSL/current/tools/rebuild	(revision 1991)
@@ -1,5 +1,5 @@
 #!/bin/ksh
 #
-#$Id: rebuild 386 2008-09-04 08:38:48Z bellier $
+#$Id: rebuild 761 2009-10-26 16:30:14Z bellier $
 #
 # This software is governed by the CeCILL license
@@ -100,4 +100,5 @@
 #-
 ${d_n}/flio_rbld < tmp.$$
+r_c=$?
 #-
 # Clear
@@ -107,3 +108,3 @@
 # End
 #-
-exit 0;
+exit ${r_c};
